## Optimieren der Likelihood aus e)

set.seed(42)

ll = function(a) -(234 * log(1-a) + 47 * log(a) + 48 * log(4*a) + 21*log(1-4*a))

wskFuerGzuK <- optim(par = 0.125, fn = ll, method = "L-BFGS-B", lower = 0, upper = 0.2499999)$par
wskFuerKzuG <- 4 * wskFuerGzuK
wskFuerGzuG <- 1 - wskFuerGzuK
wskFuerKzuK <- 1 - wskFuerKzuG

## geschaetzte Uebergangsmatrix
(P <- matrix(c(wskFuerGzuG, wskFuerKzuG, wskFuerGzuK, wskFuerKzuK), ncol = 2))

# Sei G = 1 und K = 2
#
# Datensimulation

source("markovkette.r")

# beispielhafter Verlauf eines Affen
markovkette(n = 7, P = P)

retDF <- data.frame(time = 0:7, sapply(1:50, function(i) markovkette(n = 7, P=P, plot = FALSE)[,2]))

# logit fuer Uebergang von G aus
# 
ueGG <- rep(NA, 7)
ueGK <- rep(NA, 7)

for(i in 1:7){
  
  nrFromG <- sum(fromG <- retDF[i, -1] == 1)
                   
  ueGG[i] <- sum(retDF[i+1, c(FALSE,fromG)] == 1)
  ueGK[i] <- nrFromG - ueGG[i]
  
}

time <- 1:7

summary(glm(cbind(ueGG, ueGK) ~ 1 + time, family = binomial()))

# logit fuer Uebergang von K aus
# 
ueKK <- rep(NA, 7)
ueKG <- rep(NA, 7)

for(i in 1:7){
  
  nrFromK <- sum(fromK <- retDF[i, -1] == 2)
  
  ueKK[i] <- sum(retDF[i+1, c(FALSE,fromK)] == 2)
  ueKG[i] <- nrFromK - ueKK[i]
  
}

time <- 1:7

summary(glm(cbind(ueKK, ueKG) ~ 1 + time, family = binomial()))


